import asyncio
from concurrent.futures import ProcessPoolExecutor

from v6d2ctx.context import Benchmark

from v6d3music.utils.extract import extract


async def aextract(params: dict, url: str, **kwargs):
    with Benchmark('AEX'):
        with ProcessPoolExecutor() as pool:
            return await asyncio.get_running_loop().run_in_executor(
                pool,
                extract,
                params,
                url,
                kwargs
            )
